<?php
/**
 * Writer Portfolio functions and definitions
 *
 * @package Writer Portfolio
 */

if ( ! defined( 'WRITER_PORTFOLIO_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'WRITER_PORTFOLIO_VERSION', '1.0.0' );
}

function writer_portfolio_setup() {

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'writer-portfolio' ),
			'social-menu' => esc_html__('Social Menu', 'writer-portfolio'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'writer_portfolio_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'writer_portfolio_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $writer_portfolio_content_width
 */
function writer_portfolio_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'writer_portfolio_content_width', 640 );
}
add_action( 'after_setup_theme', 'writer_portfolio_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function writer_portfolio_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'writer-portfolio' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'writer-portfolio' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'writer-portfolio' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'writer-portfolio' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'writer-portfolio' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'writer-portfolio' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'writer-portfolio' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'writer-portfolio' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'writer_portfolio_widgets_init' );


function writer_portfolio_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */

function writer_portfolio_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => rawurlencode('Anton|Roboto:ital,wght@0,100..900;1,100..900'),
        'display' => 'swap',
    );
    wp_enqueue_style('writer-portfolio-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-5', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-5/css/all.min.css', array(), '5.15.3');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), wp_get_theme()->get('Version'));

    // Main stylesheet
    wp_enqueue_style('writer-portfolio-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Add custom inline styles
    require get_parent_theme_file_path('/custom-style.php');
	wp_add_inline_style('writer-portfolio-style', $writer_portfolio_custom_css);

    // RTL styles if needed
    if (file_exists(get_stylesheet_directory() . '/rtl.css')) {
        wp_style_add_data('writer-portfolio-style', 'rtl', 'replace');
    }

    // Navigation script
    wp_enqueue_script('writer-portfolio-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Custom script
    wp_enqueue_script('writer-portfolio-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'writer_portfolio_scripts');

if (!function_exists('writer_portfolio_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function writer_portfolio_related_post($post_id){        
        $writer_portfolio_categories = get_the_category($post_id);
        if ($writer_portfolio_categories) {
            $writer_portfolio_category_ids = array();
            $writer_portfolio_category = get_category($writer_portfolio_category_ids);
            $writer_portfolio_categories = get_the_category($post_id);
            foreach ($writer_portfolio_categories as $writer_portfolio_category) {
                $writer_portfolio_category_ids[] = $writer_portfolio_category->term_id;
            }
            $writer_portfolio_count = $writer_portfolio_category->category_count;
            if ($writer_portfolio_count > 1) { ?>

         	<?php
		$writer_portfolio_related_post_wrap = absint(get_theme_mod('writer_portfolio_enable_related_post', 1));
		if($writer_portfolio_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('writer_portfolio_related_post_text', __('Related Post', 'writer-portfolio'))); ?></h2>
                    <?php
                    $writer_portfolio_cat_post_args = array(
                        'category__in' => $writer_portfolio_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'writer_portfolio_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $writer_portfolio_featured_query = new WP_Query($writer_portfolio_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($writer_portfolio_featured_query->have_posts()) :

                        while ($writer_portfolio_featured_query->have_posts()) : $writer_portfolio_featured_query->the_post();
                            ?>
                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php writer_portfolio_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $writer_portfolio_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/Faded-Story.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $writer_portfolio_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        writer_portfolio_posted_on();
                                        writer_portfolio_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('writer_portfolio_related_posts', 'writer_portfolio_related_post', 10, 1);

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$writer_portfolio_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function writer_portfolio_sanitize_checkbox($writer_portfolio_checked)
{
    // Boolean check.
    return ((isset($writer_portfolio_checked) && true == $writer_portfolio_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function writer_portfolio_enqueue_function() {

	/**
    * GET START.
    */
    require get_template_directory() . '/getstarted/writer_portfolio_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/writer_portfolio_config_file.php';

    define('WRITER_PORTFOLIO_FREE_SUPPORT',__('https://wordpress.org/support/theme/writer-portfolio/','writer-portfolio'));
    define('WRITER_PORTFOLIO_PRO_SUPPORT',__('https://www.revolutionwp.com/support/revolution-wp/','writer-portfolio'));
    define('WRITER_PORTFOLIO_REVIEW',__('https://wordpress.org/support/theme/writer-portfolio/reviews/','writer-portfolio'));
    define('WRITER_PORTFOLIO_BUY_NOW',__('https://www.revolutionwp.com/products/writer-portfolio-wordpress-theme','writer-portfolio'));
    define('WRITER_PORTFOLIO_LIVE_DEMO',__('https://demo.revolutionwp.com/writer-portfolio-pro/','writer-portfolio'));
    define('WRITER_PORTFOLIO_PRO_DOC',__('https://www.revolutionwp.com/wpdocs/writer-portfolio-pro/','writer-portfolio'));
    define('WRITER_PORTFOLIO_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/writer-portfolio-free/','writer-portfolio'));

}
add_action( 'after_setup_theme', 'writer_portfolio_enqueue_function' );

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function writer_portfolio_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'writer_portfolio_remove_customize_register', 11 );

/************************************************************************************/

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'writer_portfolio_loop_columns');

if (!function_exists('writer_portfolio_loop_columns')) {

	function writer_portfolio_loop_columns() {

		$writer_portfolio_columns = get_theme_mod( 'writer_portfolio_per_columns', 3 );

		return $writer_portfolio_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'writer_portfolio_per_page', 20 );

function writer_portfolio_per_page( $writer_portfolio_cols ) {

  	$writer_portfolio_cols = get_theme_mod( 'writer_portfolio_product_per_page', 9 );

	return $writer_portfolio_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'writer_portfolio_products_args' );

function writer_portfolio_products_args( $writer_portfolio_args ) {

    $writer_portfolio_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $writer_portfolio_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $writer_portfolio_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function writer_portfolio_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --writer_portfolio_logo_width: <?php echo absint(get_theme_mod('writer_portfolio_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('writer_portfolio_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'writer_portfolio_custom_css' );

function writer_portfolio_sanitize_choices( $writer_portfolio_input, $writer_portfolio_setting ) {
    global $wp_customize; 
    $writer_portfolio_control = $wp_customize->get_control( $writer_portfolio_setting->id ); 
    if ( array_key_exists( $writer_portfolio_input, $writer_portfolio_control->choices ) ) {
        return $writer_portfolio_input;
    } else {
        return $writer_portfolio_setting->default;
    }
}

//Excerpt 
function writer_portfolio_excerpt_function($writer_portfolio_excerpt_count = 35) {
    $writer_portfolio_excerpt = get_the_excerpt();
    $writer_portfolio_text_excerpt = wp_strip_all_tags($writer_portfolio_excerpt);
    $writer_portfolio_excerpt_limit = (int) get_theme_mod('writer_portfolio_excerpt_limit', $writer_portfolio_excerpt_count);
    $writer_portfolio_words = preg_split('/\s+/', $writer_portfolio_text_excerpt); 
    $writer_portfolio_trimmed_words = array_slice($writer_portfolio_words, 0, $writer_portfolio_excerpt_limit);
    $writer_portfolio_theme_excerpt = implode(' ', $writer_portfolio_trimmed_words);

    return $writer_portfolio_theme_excerpt;
}

// Add admin notice
function writer_portfolio_admin_notice() { 
    global $pagenow;
    $writer_portfolio_theme_args      = wp_get_theme();
    $writer_portfolio_meta            = get_option( 'writer_portfolio_admin_notice' );
    $name            = $writer_portfolio_theme_args->__get( 'Name' );
    $writer_portfolio_current_screen  = get_current_screen();

    if( !$writer_portfolio_meta ){
        if( is_network_admin() ){
            return;
        }

        if( ! current_user_can( 'manage_options' ) ){
            return;
        } 
        
        if( $writer_portfolio_current_screen->base !== 'appearance_page_writer_portfolio_guide' && 
            $writer_portfolio_current_screen->base !== 'toplevel_page_writerportfolio-demoimport' ) { ?>

            <div class="notice notice-success writer-portfolio-welcome-notice">
                <p class="writer-portfolio-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'writer_portfolio_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'writer-portfolio' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="writer-portfolio-welcome-notice-wrap">
                    <h2 class="writer-portfolio-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $writer_portfolio_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'writer-portfolio' ), $writer_portfolio_theme_name ) );
                        ?>
                    </h2>
                    <p class="writer-portfolio-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'writer-portfolio' ); ?>
                    </p>

                    <div class="writer-portfolio-welcome-info">
                        <div class="writer-portfolio-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'writer-portfolio' ); ?>">
                        </div>

                        <div class="writer-portfolio-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'writer-portfolio' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'writer-portfolio' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=writerportfolio-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'writer-portfolio' ); ?></a></p>
                        </div>

                        <div class="writer-portfolio-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'writer-portfolio' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'writer-portfolio' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=writer-portfolio-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'writer-portfolio' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

    }
}

add_action( 'admin_notices', 'writer_portfolio_admin_notice' );

if( ! function_exists( 'writer_portfolio_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function writer_portfolio_update_admin_notice(){
    if ( isset( $_GET['writer_portfolio_admin_notice'] ) && $_GET['writer_portfolio_admin_notice'] = '1' ) {
        update_option( 'writer_portfolio_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'writer_portfolio_update_admin_notice' );

add_action('after_switch_theme', 'writer_portfolio_setup_options');
function writer_portfolio_setup_options () {
    update_option('writer_portfolio_admin_notice', FALSE );
}

// changelog
function writer_portfolio_get_changelog_from_readme() {
    $writer_portfolio_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($writer_portfolio_file_path)) {
        $writer_portfolio_content = file_get_contents($writer_portfolio_file_path);

        // Extract changelog section
        $writer_portfolio_changelog_start = strpos($writer_portfolio_content, "== Changelog ==");
        $writer_portfolio_changelog = substr($writer_portfolio_content, $writer_portfolio_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $writer_portfolio_changelog, $writer_portfolio_matches, PREG_SET_ORDER);
        
        return $writer_portfolio_matches;
    }
    return [];
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );